#include <bits/stdc++.h>

using namespace std;

int main()
{
     ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    short T;
    cin >>T;

    for(short t=0;t<T;t++)
    {
        int N, M;
        cin >>N>>M;
        vector <unsigned long long> prihvacene (N);
        vector <unsigned long long> odbijene (M);
        for (int i=0;i<N;i++)
            cin>>prihvacene[i];
        for (int i=0;i<M;i++)
            cin>>odbijene[i];
         sort(prihvacene.begin(), prihvacene.end());
         int d = prihvacene[1] - prihvacene[0];
         sort(odbijene.begin(), odbijene.end());
         int odb = odbijene[1] - odbijene[0];
         int pravilo1=max(d,odb);
         int pravilo2=min(d,odb);
         if (pravilo1%pravilo2 !=0)
             cout << "1" << "\n";
          else
          {
             int medjuniz=abs(odbijene[0]-prihvacene[1]);
             int pravilo3=max(medjuniz, pravilo1);
             int pravilo4=min(medjuniz, pravilo1);
              if (pravilo3%pravilo4 !=0)
                  cout << "1" << "\n";
              else  cout << "0" << "\n";
          }

    }
    return 0;
}